package com.zcloud.controller.bus;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import org.apache.shiro.authz.annotation.RequiresPermissions;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import com.zcloud.entity.PageData;
import com.zcloud.service.bus.TokenService;
import com.zcloud.service.bus.VideoManagerService;

/**
 * 说明：视频管理
 * 作者：luoxiaobao
 * 时间：2021-05-10
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/videomanager")
public class VideoManagerController extends BaseController {

	@Autowired
	private VideoManagerService videomanagerService;
	@Autowired
	private TokenService tokenService;
	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
//	@RequiresPermissions("videomanager:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("VIDEOMANAGER_ID", this.get32UUID());	//主键
		pd.put("OPDATE", DateUtil.date2Str(new Date()));	//操作日期
		pd.put("OPUSER",Jurisdiction.getUsername());	//操作人
		pd.put("ISDELETE", "0");	//是否删除
		pd.put("ISSHOW", "0");	//是否显示
		videomanagerService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
//	@RequiresPermissions("videomanager:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		videomanagerService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
//	@RequiresPermissions("videomanager:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		videomanagerService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
//	@RequiresPermissions("videomanager:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		page.setPd(pd);
		List<PageData>	varList = videomanagerService.list(page);	//列出VideoManager列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
//	@RequiresPermissions("videomanager:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = videomanagerService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping(value="/govideo")
	@ResponseBody
	public Object govideo() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = videomanagerService.findById(pd);	//根据ID读取
		List<PageData>	varList =tokenService.listAll(pd);
		pd.put("token", varList.get(0).getString("TOKEN"));
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping(value="/govideoall")
	@ResponseBody
	public Object govideoall() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		List<PageData>	videoList = videomanagerService.listAll(pd);	//根据ID读取
		String videostr="";
		for(PageData video:videoList) {
			videostr+=video.getString("VIDEOURL")+",";
		}
		List<PageData>	varList =tokenService.listAll(pd);
		pd.put("token", varList.get(0).getString("TOKEN"));
		map.put("pd", pd);
		map.put("videostr", videostr.substring(0, videostr.length()-1));
		map.put("count", videoList.size());
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
//	@RequiresPermissions("videomanager:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			videomanagerService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
//	@RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("企业ID");	//1
		titles.add("视频名称");	//2
		titles.add("播放地址");	//3
		titles.add("操作日期");	//4
		titles.add("操作人");	//5
		titles.add("是否删除");	//6
		dataMap.put("titles", titles);
		List<PageData> varOList = videomanagerService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("CORPINFO_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("VIDEONAME"));	    //2
			vpd.put("var3", varOList.get(i).getString("VIDEOURL"));	    //3
			vpd.put("var4", varOList.get(i).getString("OPDATE"));	    //4
			vpd.put("var5", varOList.get(i).getString("OPUSER"));	    //5
			vpd.put("var6", varOList.get(i).getString("ISDELETE"));	    //6
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}
	/**列表 数据置顶
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/editZhiding")
	@RequiresPermissions("video:edit")
	@ResponseBody
//	@LogAnno(menuType= "综合管理",menuServer= "学习园地",instructionsOperate = "企业视频",instructionsType = "数据置顶列表")
	public Object editZhiding() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		if(Tools.isEmpty(Jurisdiction.getCORPINFO_ID())) {
			pd.put("CORPINFO_TYPE", "2");
		}else {
			pd.put("CORPINFO_TYPE", "1");
			pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		}
		pd.put("ISSHOW", "0");//重置置顶信息。把所有的数据全部取消置顶
		videomanagerService.editZhiding(pd);
		pd = new PageData();
		pd = this.getPageData();
		pd.put("ISSHOW", "1");
		videomanagerService.editZhiding(pd);//置顶信息
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}
}
